Loading...
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43
44# cross-compilation prefix
45CROSS=
46
47# mkimage wrapper script
48MKIMAGE=$srctree/scripts/mkuboot.sh
49
50# directory for object and other files used by this script
51object=arch/powerpc/boot
52objbin=$object
53dtc=scripts/dtc/dtc
54
55# directory for working files
56tmpdir=.
57
58usage() {
59 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
60 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
61 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
62 exit 1
63}
64
65while [ "$#" -gt 0 ]; do
66 case "$1" in
67 -o)
68 shift
69 [ "$#" -gt 0 ] || usage
70 ofile="$1"
71 ;;
72 -p)
73 shift
74 [ "$#" -gt 0 ] || usage
75 platform="$1"
76 ;;
77 -i)
78 shift
79 [ "$#" -gt 0 ] || usage
80 initrd="$1"
81 ;;
82 -d)
83 shift
84 [ "$#" -gt 0 ] || usage
85 dtb="$1"
86 ;;
87 -s)
88 shift
89 [ "$#" -gt 0 ] || usage
90 dts="$1"
91 ;;
92 -c)
93 cacheit=y
94 ;;
95 -C)
96 shift
97 [ "$#" -gt 0 ] || usage
98 CROSS="$1"
99 ;;
100 -D)
101 shift
102 [ "$#" -gt 0 ] || usage
103 object="$1"
104 objbin="$1"
105 ;;
106 -W)
107 shift
108 [ "$#" -gt 0 ] || usage
109 tmpdir="$1"
110 ;;
111 --no-gzip)
112 gzip=
113 ;;
114 -?)
115 usage
116 ;;
117 *)
118 [ -z "$kernel" ] || usage
119 kernel="$1"
120 ;;
121 esac
122 shift
123done
124
125if [ -n "$dts" ]; then
126 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127 dts="$object/dts/$dts"
128 fi
129 if [ -z "$dtb" ]; then
130 dtb="$platform.dtb"
131 fi
132 $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136 kernel=vmlinux
137fi
138
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
146link_address='0x400000'
147
148case "$platform" in
149pseries)
150 platformo=$object/of.o
151 link_address='0x4000000'
152 ;;
153maple)
154 platformo=$object/of.o
155 link_address='0x400000'
156 ;;
157pmac|chrp)
158 platformo=$object/of.o
159 ;;
160coff)
161 platformo="$object/crt0.o $object/of.o"
162 lds=$object/zImage.coff.lds
163 link_address='0x500000'
164 pie=
165 ;;
166miboot|uboot)
167 # miboot and U-boot want just the bare bits, not an ELF binary
168 ext=bin
169 objflags="-O binary"
170 tmp="$ofile"
171 ksection=image
172 isection=initrd
173 ;;
174cuboot*)
175 binary=y
176 gzip=
177 case "$platform" in
178 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
179 platformo=$object/cuboot-8xx.o
180 ;;
181 *5200*|*-motionpro)
182 platformo=$object/cuboot-52xx.o
183 ;;
184 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
185 platformo=$object/cuboot-pq2.o
186 ;;
187 *-mpc824*)
188 platformo=$object/cuboot-824x.o
189 ;;
190 *-mpc83*|*-asp834x*)
191 platformo=$object/cuboot-83xx.o
192 ;;
193 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
194 platformo=$object/cuboot-85xx-cpm2.o
195 ;;
196 *-mpc85*|*-tqm85*|*-sbc85*)
197 platformo=$object/cuboot-85xx.o
198 ;;
199 *-amigaone)
200 link_address='0x800000'
201 ;;
202 esac
203 ;;
204ps3)
205 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
206 lds=$object/zImage.ps3.lds
207 gzip=
208 ext=bin
209 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
210 ksection=.kernel:vmlinux.bin
211 isection=.kernel:initrd
212 link_address=''
213 pie=
214 ;;
215ep88xc|ep405|ep8248e)
216 platformo="$object/fixed-head.o $object/$platform.o"
217 binary=y
218 ;;
219adder875-redboot)
220 platformo="$object/fixed-head.o $object/redboot-8xx.o"
221 binary=y
222 ;;
223simpleboot-virtex405-*)
224 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
225 binary=y
226 ;;
227simpleboot-virtex440-*)
228 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
229 binary=y
230 ;;
231simpleboot-*)
232 platformo="$object/fixed-head.o $object/simpleboot.o"
233 binary=y
234 ;;
235asp834x-redboot)
236 platformo="$object/fixed-head.o $object/redboot-83xx.o"
237 binary=y
238 ;;
239xpedite52*)
240 link_address='0x1400000'
241 platformo=$object/cuboot-85xx.o
242 ;;
243gamecube|wii)
244 link_address='0x600000'
245 platformo="$object/$platform-head.o $object/$platform.o"
246 ;;
247treeboot-iss4xx-mpic)
248 platformo="$object/treeboot-iss4xx.o"
249 ;;
250epapr)
251 link_address='0x20000000'
252 pie=-pie
253 ;;
254esac
255
256vmz="$tmpdir/`basename \"$kernel\"`.$ext"
257if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
258 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
259
260 if [ -n "$gzip" ]; then
261 gzip -n -f -9 "$vmz.$$"
262 fi
263
264 if [ -n "$cacheit" ]; then
265 mv -f "$vmz.$$$gzip" "$vmz$gzip"
266 else
267 vmz="$vmz.$$"
268 fi
269fi
270
271vmz="$vmz$gzip"
272
273# Extract kernel version information, some platforms want to include
274# it in the image header
275version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
276 cut -d' ' -f3`
277if [ -n "$version" ]; then
278 uboot_version="-n Linux-$version"
279fi
280
281# physical offset of kernel image
282membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
283
284case "$platform" in
285uboot)
286 rm -f "$ofile"
287 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
288 $uboot_version -d "$vmz" "$ofile"
289 if [ -z "$cacheit" ]; then
290 rm -f "$vmz"
291 fi
292 exit 0
293 ;;
294esac
295
296addsec() {
297 ${CROSS}objcopy $4 $1 \
298 --add-section=$3="$2" \
299 --set-section-flags=$3=contents,alloc,load,readonly,data
300}
301
302addsec $tmp "$vmz" $ksection $object/empty.o
303if [ -z "$cacheit" ]; then
304 rm -f "$vmz"
305fi
306
307if [ -n "$initrd" ]; then
308 addsec $tmp "$initrd" $isection
309fi
310
311if [ -n "$dtb" ]; then
312 addsec $tmp "$dtb" .kernel:dtb
313 if [ -n "$dts" ]; then
314 rm $dtb
315 fi
316fi
317
318if [ "$platform" != "miboot" ]; then
319 if [ -n "$link_address" ] ; then
320 text_start="-Ttext $link_address"
321 fi
322 ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
323 $platformo $tmp $object/wrapper.a
324 rm $tmp
325fi
326
327# Some platforms need the zImage's entry point and base address
328base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
329entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
330
331if [ -n "$binary" ]; then
332 mv "$ofile" "$ofile".elf
333 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
334fi
335
336# post-processing needed for some platforms
337case "$platform" in
338pseries|chrp|maple)
339 $objbin/addnote "$ofile"
340 ;;
341coff)
342 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
343 $objbin/hack-coff "$ofile"
344 ;;
345cuboot*)
346 gzip -n -f -9 "$ofile"
347 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
348 $uboot_version -d "$ofile".gz "$ofile"
349 ;;
350treeboot*)
351 mv "$ofile" "$ofile.elf"
352 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
353 if [ -z "$cacheit" ]; then
354 rm -f "$ofile.elf"
355 fi
356 exit 0
357 ;;
358ps3)
359 # The ps3's loader supports loading a gzipped binary image from flash
360 # rom to ram addr zero. The loader then enters the system reset
361 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
362 # a binary image of the kernel to be at addr zero, and yet have a
363 # suitable bootwrapper entry at 0x100. To construct the final rom
364 # image 512 bytes from offset 0x100 is copied to the bootwrapper
365 # place holder at symbol __system_reset_kernel. The 512 bytes of the
366 # bootwrapper entry code at symbol __system_reset_overlay is then
367 # copied to offset 0x100. At runtime the bootwrapper program copies
368 # the data at __system_reset_kernel back to addr 0x100.
369
370 system_reset_overlay=0x`${CROSS}nm "$ofile" \
371 | grep ' __system_reset_overlay$' \
372 | cut -d' ' -f1`
373 system_reset_overlay=`printf "%d" $system_reset_overlay`
374 system_reset_kernel=0x`${CROSS}nm "$ofile" \
375 | grep ' __system_reset_kernel$' \
376 | cut -d' ' -f1`
377 system_reset_kernel=`printf "%d" $system_reset_kernel`
378 overlay_dest="256"
379 overlay_size="512"
380
381 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
382
383 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
384 skip=$overlay_dest seek=$system_reset_kernel \
385 count=$overlay_size bs=1
386
387 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
388 skip=$system_reset_overlay seek=$overlay_dest \
389 count=$overlay_size bs=1
390
391 odir="$(dirname "$ofile.bin")"
392 rm -f "$odir/otheros.bld"
393 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
394 ;;
395esac
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32fi
33
34# defaults
35kernel=
36ofile=zImage
37platform=of
38initrd=
39dtb=
40dts=
41esm_blob=
42cacheit=
43binary=
44compression=.gz
45uboot_comp=gzip
46pie=
47format=
48
49# cross-compilation prefix
50CROSS=
51
52# mkimage wrapper script
53MKIMAGE=$srctree/scripts/mkuboot.sh
54
55# directory for object and other files used by this script
56object=arch/powerpc/boot
57objbin=$object
58dtc=scripts/dtc/dtc
59
60# directory for working files
61tmpdir=.
62
63usage() {
64 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
65 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
66 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
67 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
68 exit 1
69}
70
71run_cmd() {
72 if [ "$V" = 1 ]; then
73 $* 2>&1
74 else
75 local msg
76
77 set +e
78 msg=$($* 2>&1)
79
80 if [ $? -ne "0" ]; then
81 echo $msg
82 exit 1
83 fi
84 set -e
85 fi
86}
87
88while [ "$#" -gt 0 ]; do
89 case "$1" in
90 -o)
91 shift
92 [ "$#" -gt 0 ] || usage
93 ofile="$1"
94 ;;
95 -p)
96 shift
97 [ "$#" -gt 0 ] || usage
98 platform="$1"
99 ;;
100 -i)
101 shift
102 [ "$#" -gt 0 ] || usage
103 initrd="$1"
104 ;;
105 -d)
106 shift
107 [ "$#" -gt 0 ] || usage
108 dtb="$1"
109 ;;
110 -e)
111 shift
112 [ "$#" -gt 0 ] || usage
113 esm_blob="$1"
114 ;;
115 -s)
116 shift
117 [ "$#" -gt 0 ] || usage
118 dts="$1"
119 ;;
120 -c)
121 cacheit=y
122 ;;
123 -C)
124 shift
125 [ "$#" -gt 0 ] || usage
126 CROSS="$1"
127 ;;
128 -D)
129 shift
130 [ "$#" -gt 0 ] || usage
131 object="$1"
132 objbin="$1"
133 ;;
134 -W)
135 shift
136 [ "$#" -gt 0 ] || usage
137 tmpdir="$1"
138 ;;
139 -z)
140 compression=.gz
141 uboot_comp=gzip
142 ;;
143 -Z)
144 shift
145 [ "$#" -gt 0 ] || usage
146 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
147
148 compression=".$1"
149 uboot_comp=$1
150
151 if [ $compression = ".none" ]; then
152 compression=
153 uboot_comp=none
154 fi
155 if [ $uboot_comp = "gz" ]; then
156 uboot_comp=gzip
157 fi
158 ;;
159 --no-gzip)
160 # a "feature" of the the wrapper script is that it can be used outside
161 # the kernel tree. So keeping this around for backwards compatibility.
162 compression=
163 uboot_comp=none
164 ;;
165 -?)
166 usage
167 ;;
168 *)
169 [ -z "$kernel" ] || usage
170 kernel="$1"
171 ;;
172 esac
173 shift
174done
175
176
177if [ -n "$dts" ]; then
178 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
179 dts="$object/dts/$dts"
180 fi
181 if [ -z "$dtb" ]; then
182 dtb="$platform.dtb"
183 fi
184 $dtc -O dtb -o "$dtb" -b 0 "$dts"
185fi
186
187if [ -z "$kernel" ]; then
188 kernel=vmlinux
189fi
190
191LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
192case "$elfformat" in
193 elf64-powerpcle) format=elf64lppc ;;
194 elf64-powerpc) format=elf32ppc ;;
195 elf32-powerpc) format=elf32ppc ;;
196esac
197
198ld_version()
199{
200 # Poached from scripts/ld-version.sh, but we don't want to call that because
201 # this script (wrapper) is distributed separately from the kernel source.
202 # Extract linker version number from stdin and turn into single number.
203 awk '{
204 gsub(".*\\)", "");
205 gsub(".*version ", "");
206 gsub("-.*", "");
207 split($1,a, ".");
208 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
209 exit
210 }'
211}
212
213# Do not include PT_INTERP segment when linking pie. Non-pie linking
214# just ignores this option.
215LD_VERSION=$(${CROSS}ld --version | ld_version)
216LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
217if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
218 nodl="--no-dynamic-linker"
219fi
220
221platformo=$object/"$platform".o
222lds=$object/zImage.lds
223ext=strip
224objflags=-S
225tmp=$tmpdir/zImage.$$.o
226ksection=.kernel:vmlinux.strip
227isection=.kernel:initrd
228esection=.kernel:esm_blob
229link_address='0x400000'
230make_space=y
231
232
233if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
234 echo "ESM blob not support on non-pseries platforms" >&2
235 exit 1
236fi
237
238case "$platform" in
239of)
240 platformo="$object/of.o $object/epapr.o"
241 make_space=n
242 ;;
243pseries)
244 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
245 link_address='0x4000000'
246 if [ "$format" != "elf32ppc" ]; then
247 link_address=
248 pie=-pie
249 fi
250 make_space=n
251 ;;
252maple)
253 platformo="$object/of.o $object/epapr.o"
254 link_address='0x400000'
255 make_space=n
256 ;;
257pmac|chrp)
258 platformo="$object/of.o $object/epapr.o"
259 make_space=n
260 ;;
261coff)
262 platformo="$object/crt0.o $object/of.o $object/epapr.o"
263 lds=$object/zImage.coff.lds
264 link_address='0x500000'
265 make_space=n
266 pie=
267 ;;
268miboot|uboot*)
269 # miboot and U-boot want just the bare bits, not an ELF binary
270 ext=bin
271 objflags="-O binary"
272 tmp="$ofile"
273 ksection=image
274 isection=initrd
275 ;;
276cuboot*)
277 binary=y
278 compression=
279 case "$platform" in
280 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
281 platformo=$object/cuboot-8xx.o
282 ;;
283 *5200*|*-motionpro)
284 platformo=$object/cuboot-52xx.o
285 ;;
286 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
287 platformo=$object/cuboot-pq2.o
288 ;;
289 *-mpc824*)
290 platformo=$object/cuboot-824x.o
291 ;;
292 *-mpc83*|*-asp834x*)
293 platformo=$object/cuboot-83xx.o
294 ;;
295 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
296 platformo=$object/cuboot-85xx-cpm2.o
297 ;;
298 *-mpc85*|*-tqm85*|*-sbc85*)
299 platformo=$object/cuboot-85xx.o
300 ;;
301 *-amigaone)
302 link_address='0x800000'
303 ;;
304 esac
305 ;;
306ps3)
307 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
308 lds=$object/zImage.ps3.lds
309 compression=
310 ext=bin
311 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
312 ksection=.kernel:vmlinux.bin
313 isection=.kernel:initrd
314 link_address=''
315 make_space=n
316 pie=
317 ;;
318ep88xc|ep405|ep8248e)
319 platformo="$object/fixed-head.o $object/$platform.o"
320 binary=y
321 ;;
322adder875-redboot)
323 platformo="$object/fixed-head.o $object/redboot-8xx.o"
324 binary=y
325 ;;
326simpleboot-virtex405-*)
327 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
328 binary=y
329 ;;
330simpleboot-virtex440-*)
331 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
332 binary=y
333 ;;
334simpleboot-*)
335 platformo="$object/fixed-head.o $object/simpleboot.o"
336 binary=y
337 ;;
338asp834x-redboot)
339 platformo="$object/fixed-head.o $object/redboot-83xx.o"
340 binary=y
341 ;;
342xpedite52*)
343 link_address='0x1400000'
344 platformo=$object/cuboot-85xx.o
345 ;;
346gamecube|wii)
347 link_address='0x600000'
348 platformo="$object/$platform-head.o $object/$platform.o"
349 ;;
350treeboot-currituck)
351 link_address='0x1000000'
352 ;;
353treeboot-akebono)
354 link_address='0x1000000'
355 ;;
356treeboot-iss4xx-mpic)
357 platformo="$object/treeboot-iss4xx.o"
358 ;;
359epapr)
360 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
361 link_address='0x20000000'
362 pie=-pie
363 ;;
364mvme5100)
365 platformo="$object/fixed-head.o $object/mvme5100.o"
366 binary=y
367 ;;
368mvme7100)
369 platformo="$object/motload-head.o $object/mvme7100.o"
370 link_address='0x4000000'
371 binary=y
372 ;;
373esac
374
375vmz="$tmpdir/`basename \"$kernel\"`.$ext"
376
377# Calculate the vmlinux.strip size
378${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
379strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
380
381if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
382 # recompress the image if we need to
383 case $compression in
384 .xz)
385 xz --check=crc32 -f -6 "$vmz.$$"
386 ;;
387 .gz)
388 gzip -n -f -9 "$vmz.$$"
389 ;;
390 .lzma)
391 xz --format=lzma -f -6 "$vmz.$$"
392 ;;
393 .lzo)
394 lzop -f -9 "$vmz.$$"
395 ;;
396 *)
397 # drop the compression suffix so the stripped vmlinux is used
398 compression=
399 uboot_comp=none
400 ;;
401 esac
402
403 if [ -n "$cacheit" ]; then
404 mv -f "$vmz.$$$compression" "$vmz$compression"
405 else
406 vmz="$vmz.$$"
407 fi
408else
409 rm -f $vmz.$$
410fi
411
412vmz="$vmz$compression"
413
414if [ "$make_space" = "y" ]; then
415 # Round the size to next higher MB limit
416 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
417
418 round_size=0x$(printf "%x" $round_size)
419 link_addr=$(printf "%d" $link_address)
420
421 if [ $link_addr -lt $strip_size ]; then
422 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
423 "overlaps the address of the wrapper($link_address)"
424 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
425 link_address=$round_size
426 fi
427fi
428
429# Extract kernel version information, some platforms want to include
430# it in the image header
431version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
432 cut -d' ' -f3`
433if [ -n "$version" ]; then
434 uboot_version="-n Linux-$version"
435fi
436
437# physical offset of kernel image
438membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
439
440case "$platform" in
441uboot)
442 rm -f "$ofile"
443 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
444 $uboot_version -d "$vmz" "$ofile"
445 if [ -z "$cacheit" ]; then
446 rm -f "$vmz"
447 fi
448 exit 0
449 ;;
450uboot-obs600)
451 rm -f "$ofile"
452 # obs600 wants a multi image with an initrd, so we need to put a fake
453 # one in even when building a "normal" image.
454 if [ -n "$initrd" ]; then
455 real_rd="$initrd"
456 else
457 real_rd=`mktemp`
458 echo "\0" >>"$real_rd"
459 fi
460 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
461 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
462 if [ -z "$initrd" ]; then
463 rm -f "$real_rd"
464 fi
465 if [ -z "$cacheit" ]; then
466 rm -f "$vmz"
467 fi
468 exit 0
469 ;;
470esac
471
472addsec() {
473 ${CROSS}objcopy $4 $1 \
474 --add-section=$3="$2" \
475 --set-section-flags=$3=contents,alloc,load,readonly,data
476}
477
478addsec $tmp "$vmz" $ksection $object/empty.o
479if [ -z "$cacheit" ]; then
480 rm -f "$vmz"
481fi
482
483if [ -n "$initrd" ]; then
484 addsec $tmp "$initrd" $isection
485fi
486
487if [ -n "$dtb" ]; then
488 addsec $tmp "$dtb" .kernel:dtb
489 if [ -n "$dts" ]; then
490 rm $dtb
491 fi
492fi
493
494if [ -n "$esm_blob" ]; then
495 addsec $tmp "$esm_blob" $esection
496fi
497
498if [ "$platform" != "miboot" ]; then
499 if [ -n "$link_address" ] ; then
500 text_start="-Ttext $link_address"
501 fi
502#link everything
503 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl -o "$ofile" \
504 $platformo $tmp $object/wrapper.a
505 rm $tmp
506fi
507
508# Some platforms need the zImage's entry point and base address
509base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
510entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
511
512if [ -n "$binary" ]; then
513 mv "$ofile" "$ofile".elf
514 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
515fi
516
517# post-processing needed for some platforms
518case "$platform" in
519pseries|chrp|maple)
520 $objbin/addnote "$ofile"
521 ;;
522coff)
523 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
524 $objbin/hack-coff "$ofile"
525 ;;
526cuboot*)
527 gzip -n -f -9 "$ofile"
528 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
529 $uboot_version -d "$ofile".gz "$ofile"
530 ;;
531treeboot*)
532 mv "$ofile" "$ofile.elf"
533 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
534 if [ -z "$cacheit" ]; then
535 rm -f "$ofile.elf"
536 fi
537 exit 0
538 ;;
539ps3)
540 # The ps3's loader supports loading a gzipped binary image from flash
541 # rom to ram addr zero. The loader then enters the system reset
542 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
543 # a binary image of the kernel to be at addr zero, and yet have a
544 # suitable bootwrapper entry at 0x100. To construct the final rom
545 # image 512 bytes from offset 0x100 is copied to the bootwrapper
546 # place holder at symbol __system_reset_kernel. The 512 bytes of the
547 # bootwrapper entry code at symbol __system_reset_overlay is then
548 # copied to offset 0x100. At runtime the bootwrapper program copies
549 # the data at __system_reset_kernel back to addr 0x100.
550
551 system_reset_overlay=0x`${CROSS}nm "$ofile" \
552 | grep ' __system_reset_overlay$' \
553 | cut -d' ' -f1`
554 system_reset_overlay=`printf "%d" $system_reset_overlay`
555 system_reset_kernel=0x`${CROSS}nm "$ofile" \
556 | grep ' __system_reset_kernel$' \
557 | cut -d' ' -f1`
558 system_reset_kernel=`printf "%d" $system_reset_kernel`
559 overlay_dest="256"
560 overlay_size="512"
561
562 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
563
564 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
565 skip=$overlay_dest seek=$system_reset_kernel \
566 count=$overlay_size bs=1
567
568 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
569 skip=$system_reset_overlay seek=$overlay_dest \
570 count=$overlay_size bs=1
571
572 odir="$(dirname "$ofile.bin")"
573 rm -f "$odir/otheros.bld"
574 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
575 ;;
576esac